xref: /linux/tools/lib/bpf/Makefile (revision f3846b3800a2cfda9c900b2e94525a1027b04424)
1# SPDX-License-Identifier: (LGPL-2.1 OR BSD-2-Clause)
2# Most of this file is copied from tools/lib/traceevent/Makefile
3
4RM ?= rm
5srctree := $(realpath $(srctree))
6
7VERSION_SCRIPT := libbpf.map
8LIBBPF_VERSION := $(shell \
9	grep -oE '^LIBBPF_([0-9.]+)' $(VERSION_SCRIPT) | \
10	sort -rV | head -n1 | cut -d'_' -f2)
11LIBBPF_MAJOR_VERSION := $(word 1,$(subst ., ,$(LIBBPF_VERSION)))
12LIBBPF_MINOR_VERSION := $(word 2,$(subst ., ,$(LIBBPF_VERSION)))
13
14MAKEFLAGS += --no-print-directory
15
16# This will work when bpf is built in tools env. where srctree
17# isn't set and when invoked from selftests build, where srctree
18# is a ".". building_out_of_srctree is undefined for in srctree
19# builds
20ifndef building_out_of_srctree
21srctree := $(patsubst %/,%,$(dir $(CURDIR)))
22srctree := $(patsubst %/,%,$(dir $(srctree)))
23srctree := $(patsubst %/,%,$(dir $(srctree)))
24#$(info Determined 'srctree' to be $(srctree))
25endif
26
27INSTALL = install
28
29# Use DESTDIR for installing into a different root directory.
30# This is useful for building a package. The program will be
31# installed in this directory as if it was the root directory.
32# Then the build tool can move it later.
33DESTDIR ?=
34DESTDIR_SQ = '$(subst ','\'',$(DESTDIR))'
35
36include $(srctree)/tools/scripts/Makefile.arch
37
38ifeq ($(LP64), 1)
39  libdir_relative = lib64
40else
41  libdir_relative = lib
42endif
43
44prefix ?= /usr/local
45libdir = $(prefix)/$(libdir_relative)
46man_dir = $(prefix)/share/man
47man_dir_SQ = '$(subst ','\'',$(man_dir))'
48
49export man_dir man_dir_SQ INSTALL
50export DESTDIR DESTDIR_SQ
51
52# Defer assigning EXTRA_CFLAGS to CFLAGS until after including
53# tools/scripts/Makefile.include, as it may add flags to EXTRA_CFLAGS.
54ifdef EXTRA_CFLAGS
55  CFLAGS :=
56else
57  CFLAGS := -g -O2
58endif
59
60include $(srctree)/tools/scripts/Makefile.include
61
62# copy a bit from Linux kbuild
63
64INCLUDES = -I$(or $(OUTPUT),.) \
65	   -I$(srctree)/tools/include -I$(srctree)/tools/include/uapi \
66	   -I$(srctree)/tools/arch/$(SRCARCH)/include
67
68export prefix libdir src obj
69
70# Shell quotes
71libdir_SQ = $(subst ','\'',$(libdir))
72libdir_relative_SQ = $(subst ','\'',$(libdir_relative))
73
74OBJ		= $@
75N		=
76
77LIB_TARGET	= libbpf.a libbpf.so.$(LIBBPF_VERSION)
78LIB_FILE	= libbpf.a libbpf.so*
79PC_FILE		= libbpf.pc
80
81# Append required CFLAGS
82override CFLAGS += -std=gnu89
83override CFLAGS += $(EXTRA_WARNINGS) -Wno-switch-enum
84override CFLAGS += -Werror -Wall
85override CFLAGS += $(INCLUDES)
86override CFLAGS += -fvisibility=hidden
87override CFLAGS += -D_LARGEFILE64_SOURCE -D_FILE_OFFSET_BITS=64
88override CFLAGS += $(EXTRA_CFLAGS)
89
90# flags specific for shared library
91SHLIB_FLAGS := -DSHARED -fPIC
92
93# Disable command line variables (CFLAGS) override from top
94# level Makefile (perf), otherwise build Makefile will get
95# the same command line setup.
96MAKEOVERRIDES=
97
98all:
99
100OUTPUT ?= ./
101OUTPUT := $(abspath $(OUTPUT))/
102export srctree OUTPUT CC LD CFLAGS V
103include $(srctree)/tools/build/Makefile.include
104
105SHARED_OBJDIR	:= $(OUTPUT)sharedobjs/
106STATIC_OBJDIR	:= $(OUTPUT)staticobjs/
107BPF_IN_SHARED	:= $(SHARED_OBJDIR)libbpf-in.o
108BPF_IN_STATIC	:= $(STATIC_OBJDIR)libbpf-in.o
109BPF_HELPER_DEFS	:= $(OUTPUT)bpf_helper_defs.h
110BPF_GENERATED	:= $(BPF_HELPER_DEFS)
111
112LIB_TARGET	:= $(addprefix $(OUTPUT),$(LIB_TARGET))
113LIB_FILE	:= $(addprefix $(OUTPUT),$(LIB_FILE))
114PC_FILE		:= $(addprefix $(OUTPUT),$(PC_FILE))
115
116TAGS_PROG := $(if $(shell which etags 2>/dev/null),etags,ctags)
117
118GLOBAL_SYM_COUNT = $(shell readelf -s --wide $(BPF_IN_SHARED) | \
119			   cut -d "@" -f1 | sed 's/_v[0-9]_[0-9]_[0-9].*//' | \
120			   sed 's/\[.*\]//' | \
121			   awk '/GLOBAL/ && /DEFAULT/ && !/UND|ABS/ {print $$NF}' | \
122			   sort -u | wc -l)
123VERSIONED_SYM_COUNT = $(shell readelf --dyn-syms --wide $(OUTPUT)libbpf.so | \
124			      sed 's/\[.*\]//' | \
125			      awk '/GLOBAL/ && /DEFAULT/ && !/UND|ABS/ {print $$NF}' | \
126			      grep -Eo '[^ ]+@LIBBPF_' | cut -d@ -f1 | sort -u | wc -l)
127
128CMD_TARGETS = $(LIB_TARGET) $(PC_FILE)
129
130all: fixdep
131	$(Q)$(MAKE) all_cmd
132
133all_cmd: $(CMD_TARGETS) check
134
135$(SHARED_OBJDIR) $(STATIC_OBJDIR):
136	$(Q)mkdir -p $@
137
138$(BPF_IN_SHARED): force $(BPF_GENERATED) | $(SHARED_OBJDIR)
139	@(test -f ../../include/uapi/linux/bpf.h -a -f ../../../include/uapi/linux/bpf.h && ( \
140	(diff -B ../../include/uapi/linux/bpf.h ../../../include/uapi/linux/bpf.h >/dev/null) || \
141	echo "Warning: Kernel ABI header at 'tools/include/uapi/linux/bpf.h' differs from latest version at 'include/uapi/linux/bpf.h'" >&2 )) || true
142	@(test -f ../../include/uapi/linux/bpf_common.h -a -f ../../../include/uapi/linux/bpf_common.h && ( \
143	(diff -B ../../include/uapi/linux/bpf_common.h ../../../include/uapi/linux/bpf_common.h >/dev/null) || \
144	echo "Warning: Kernel ABI header at 'tools/include/uapi/linux/bpf_common.h' differs from latest version at 'include/uapi/linux/bpf_common.h'" >&2 )) || true
145	@(test -f ../../include/uapi/linux/if_xdp.h -a -f ../../../include/uapi/linux/if_xdp.h && ( \
146	(diff -B ../../include/uapi/linux/if_xdp.h ../../../include/uapi/linux/if_xdp.h >/dev/null) || \
147	echo "Warning: Kernel ABI header at 'tools/include/uapi/linux/if_xdp.h' differs from latest version at 'include/uapi/linux/if_xdp.h'" >&2 )) || true
148	$(SILENT_MAKE) -C $(srctree)/tools/build CFLAGS= LDFLAGS= OUTPUT=$(SHARED_OBJDIR) $(SHARED_OBJDIR)fixdep
149	$(Q)$(MAKE) $(build)=libbpf OUTPUT=$(SHARED_OBJDIR) CFLAGS="$(CFLAGS) $(SHLIB_FLAGS)"
150
151$(BPF_IN_STATIC): force $(BPF_GENERATED) | $(STATIC_OBJDIR)
152	$(SILENT_MAKE) -C $(srctree)/tools/build CFLAGS= LDFLAGS= OUTPUT=$(STATIC_OBJDIR) $(STATIC_OBJDIR)fixdep
153	$(Q)$(MAKE) $(build)=libbpf OUTPUT=$(STATIC_OBJDIR)
154
155$(BPF_HELPER_DEFS): $(srctree)/tools/include/uapi/linux/bpf.h
156	$(QUIET_GEN)$(srctree)/scripts/bpf_doc.py --header \
157		--file $(srctree)/tools/include/uapi/linux/bpf.h > $(BPF_HELPER_DEFS)
158
159$(OUTPUT)libbpf.so: $(OUTPUT)libbpf.so.$(LIBBPF_VERSION)
160
161$(OUTPUT)libbpf.so.$(LIBBPF_VERSION): $(BPF_IN_SHARED) $(VERSION_SCRIPT)
162	$(QUIET_LINK)$(CC) $(CFLAGS) $(LDFLAGS) \
163		--shared -Wl,-soname,libbpf.so.$(LIBBPF_MAJOR_VERSION) \
164		-Wl,--version-script=$(VERSION_SCRIPT) $< -lelf -lz -o $@
165	@ln -sf $(@F) $(OUTPUT)libbpf.so
166	@ln -sf $(@F) $(OUTPUT)libbpf.so.$(LIBBPF_MAJOR_VERSION)
167
168$(OUTPUT)libbpf.a: $(BPF_IN_STATIC)
169	$(QUIET_LINK)$(RM) -f $@; $(AR) rcs $@ $^
170
171$(OUTPUT)libbpf.pc:
172	$(QUIET_GEN)sed -e "s|@PREFIX@|$(prefix)|" \
173		-e "s|@LIBDIR@|$(libdir_SQ)|" \
174		-e "s|@VERSION@|$(LIBBPF_VERSION)|" \
175		< libbpf.pc.template > $@
176
177check: check_abi check_version
178
179check_abi: $(OUTPUT)libbpf.so $(VERSION_SCRIPT)
180	@if [ "$(GLOBAL_SYM_COUNT)" != "$(VERSIONED_SYM_COUNT)" ]; then	 \
181		echo "Warning: Num of global symbols in $(BPF_IN_SHARED)"	 \
182		     "($(GLOBAL_SYM_COUNT)) does NOT match with num of"	 \
183		     "versioned symbols in $^ ($(VERSIONED_SYM_COUNT))." \
184		     "Please make sure all LIBBPF_API symbols are"	 \
185		     "versioned in $(VERSION_SCRIPT)." >&2;		 \
186		readelf -s --wide $(BPF_IN_SHARED) |			 \
187		    cut -d "@" -f1 | sed 's/_v[0-9]_[0-9]_[0-9].*//' |	 \
188		    sed 's/\[.*\]//' |					 \
189		    awk '/GLOBAL/ && /DEFAULT/ && !/UND/ {print $$NF}'|  \
190		    sort -u > $(OUTPUT)libbpf_global_syms.tmp;		 \
191		readelf --dyn-syms --wide $(OUTPUT)libbpf.so |		 \
192		    sed 's/\[.*\]//' |					 \
193		    awk '/GLOBAL/ && /DEFAULT/ && !/UND|ABS/ {print $$NF}'|  \
194		    grep -Eo '[^ ]+@LIBBPF_' | cut -d@ -f1 |		 \
195		    sort -u > $(OUTPUT)libbpf_versioned_syms.tmp; 	 \
196		diff -u $(OUTPUT)libbpf_global_syms.tmp			 \
197		     $(OUTPUT)libbpf_versioned_syms.tmp;		 \
198		rm $(OUTPUT)libbpf_global_syms.tmp			 \
199		   $(OUTPUT)libbpf_versioned_syms.tmp;			 \
200		exit 1;							 \
201	fi
202
203HDR_MAJ_VERSION := $(shell grep -oE '^$(pound)define LIBBPF_MAJOR_VERSION ([0-9]+)$$' libbpf_version.h | cut -d' ' -f3)
204HDR_MIN_VERSION := $(shell grep -oE '^$(pound)define LIBBPF_MINOR_VERSION ([0-9]+)$$' libbpf_version.h | cut -d' ' -f3)
205
206check_version: $(VERSION_SCRIPT) libbpf_version.h
207	@if [ "$(HDR_MAJ_VERSION)" != "$(LIBBPF_MAJOR_VERSION)" ]; then        \
208		echo "Error: libbpf major version mismatch detected: "	       \
209		     "'$(HDR_MAJ_VERSION)' != '$(LIBBPF_MAJOR_VERSION)'" >&2;  \
210		exit 1;							       \
211	fi
212	@if [ "$(HDR_MIN_VERSION)" != "$(LIBBPF_MINOR_VERSION)" ]; then	       \
213		echo "Error: libbpf minor version mismatch detected: "	       \
214		     "'$(HDR_MIN_VERSION)' != '$(LIBBPF_MINOR_VERSION)'" >&2;  \
215		exit 1;							       \
216	fi
217
218define do_install_mkdir
219	if [ ! -d '$(DESTDIR_SQ)$1' ]; then		\
220		$(INSTALL) -d -m 755 '$(DESTDIR_SQ)$1';	\
221	fi
222endef
223
224define do_install
225	if [ ! -d '$(DESTDIR_SQ)$2' ]; then		\
226		$(INSTALL) -d -m 755 '$(DESTDIR_SQ)$2';	\
227	fi;						\
228	$(INSTALL) $(if $3,-m $3,) $1 '$(DESTDIR_SQ)$2'
229endef
230
231install_lib: all_cmd
232	$(call QUIET_INSTALL, $(LIB_TARGET)) \
233		$(call do_install_mkdir,$(libdir_SQ)); \
234		cp -fpR $(LIB_FILE) $(DESTDIR)$(libdir_SQ)
235
236SRC_HDRS := bpf.h libbpf.h btf.h libbpf_common.h libbpf_legacy.h	     \
237	    bpf_helpers.h bpf_tracing.h bpf_endian.h bpf_core_read.h	     \
238	    skel_internal.h libbpf_version.h usdt.bpf.h
239GEN_HDRS := $(BPF_GENERATED)
240
241INSTALL_PFX := $(DESTDIR)$(prefix)/include/bpf
242INSTALL_SRC_HDRS := $(addprefix $(INSTALL_PFX)/, $(SRC_HDRS))
243INSTALL_GEN_HDRS := $(addprefix $(INSTALL_PFX)/, $(notdir $(GEN_HDRS)))
244
245$(INSTALL_SRC_HDRS): $(INSTALL_PFX)/%.h: %.h
246	$(call QUIET_INSTALL, $@) \
247		$(call do_install,$<,$(prefix)/include/bpf,644)
248
249$(INSTALL_GEN_HDRS): $(INSTALL_PFX)/%.h: $(OUTPUT)%.h
250	$(call QUIET_INSTALL, $@) \
251		$(call do_install,$<,$(prefix)/include/bpf,644)
252
253install_headers: $(BPF_GENERATED) $(INSTALL_SRC_HDRS) $(INSTALL_GEN_HDRS)
254	$(call QUIET_INSTALL, libbpf_headers)
255
256install_pkgconfig: $(PC_FILE)
257	$(call QUIET_INSTALL, $(PC_FILE)) \
258		$(call do_install,$(PC_FILE),$(libdir_SQ)/pkgconfig,644)
259
260install: install_lib install_pkgconfig install_headers
261
262clean: fixdep-clean
263	$(call QUIET_CLEAN, libbpf) $(RM) -rf $(CMD_TARGETS)		     \
264		*~ .*.d .*.cmd LIBBPF-CFLAGS $(BPF_GENERATED)		     \
265		$(SHARED_OBJDIR) $(STATIC_OBJDIR)			     \
266		$(addprefix $(OUTPUT),					     \
267			    *.o *.a *.so *.so.$(LIBBPF_MAJOR_VERSION) *.pc)
268
269PHONY += force cscope tags check check_abi check_version
270force:
271
272cscope:
273	ls *.c *.h > cscope.files
274	cscope -b -q -I $(srctree)/include -f cscope.out
275
276tags:
277	$(RM) -f TAGS tags
278	ls *.c *.h | xargs $(TAGS_PROG) -a
279
280# Declare the contents of the .PHONY variable as phony.  We keep that
281# information in a variable so we can use it in if_changed and friends.
282.PHONY: $(PHONY)
283
284# Delete partially updated (corrupted) files on error
285.DELETE_ON_ERROR:
286
287help:
288	@echo 'libbpf common targets:'
289	@echo '  HINT: use "V=1" to enable verbose build'
290	@echo '  all     - build libraries and pkgconfig'
291	@echo '  clean   - remove all generated files'
292	@echo '  check   - check ABI and version info'
293	@echo ''
294	@echo 'libbpf install targets:'
295	@echo '  HINT: use "prefix"(defaults to "/usr/local") or "DESTDIR" (defaults to "/")'
296	@echo '        to adjust target destination, e.g. "make prefix=/usr/local install"'
297	@echo '  install          - build and install all headers, libraries and pkgconfig'
298	@echo '  install_headers  - install only headers to include/bpf'
299	@echo ''
300	@echo 'libbpf make targets:'
301	@echo '  tags    - use ctags to make tag information for source code browsing'
302	@echo '  cscope  - use cscope to make interactive source code browsing database'
303